/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.modules.pl.processConfig.controller;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import lombok.AllArgsConstructor;
import javax.validation.Valid;

import org.springblade.core.secure.BladeUser;
import org.springblade.core.mp.support.Condition;
import org.springblade.core.mp.support.Query;
import org.springblade.core.secure.utils.AuthUtil;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.Func;
import org.springblade.modules.pl.process.entity.ProcessEntity;
import org.springblade.modules.pl.process.service.IProcessService;
import org.springblade.modules.pl.product.entity.ProductEntity;
import org.springframework.web.bind.annotation.*;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springblade.modules.pl.processConfig.entity.ProcessConfigEntity;
import org.springblade.modules.pl.processConfig.vo.ProcessConfigVO;
import org.springblade.modules.pl.processConfig.excel.ProcessConfigExcel;
import org.springblade.modules.pl.processConfig.wrapper.ProcessConfigWrapper;
import org.springblade.modules.pl.processConfig.service.IProcessConfigService;
import org.springblade.core.boot.ctrl.BladeController;
import org.springblade.core.tool.utils.DateUtil;
import org.springblade.core.excel.util.ExcelUtil;
import org.springblade.core.tool.constant.BladeConstant;
import springfox.documentation.annotations.ApiIgnore;

import java.sql.Wrapper;
import java.util.ArrayList;
import java.util.Map;
import java.util.List;
import java.util.stream.Collectors;
import javax.servlet.http.HttpServletResponse;

/**
 * 工序配置表 控制器
 *
 * @author BladeX
 * @since 2024-04-21
 */
@RestController
@AllArgsConstructor
@RequestMapping("pl-processConfig/processConfig")
@Api(value = "工序配置表", tags = "工序配置表接口")
public class ProcessConfigController extends BladeController {

	private final IProcessConfigService processConfigService;
	private final IProcessService processService;

	/**
	 * 工序配置表 详情
	 */
	@GetMapping("/detail")
	@ApiOperationSupport(order = 1)
	@ApiOperation(value = "详情", notes = "传入processConfig")
	public R<ProcessConfigVO> detail(ProcessConfigEntity processConfig) {
		ProcessConfigEntity detail = processConfigService.getOne(Condition.getQueryWrapper(processConfig));
		return R.data(ProcessConfigWrapper.build().entityVO(detail));
	}
	/**
	 * 工序配置表 分页
	 */
	@GetMapping("/list")
	@ApiOperationSupport(order = 2)
	@ApiOperation(value = "分页", notes = "传入processConfig")
	public R<IPage<ProcessConfigVO>> list(@ApiIgnore @RequestParam Map<String, Object> processConfig, Query query) {
		query.setDescs("create_time");
		BladeUser user = AuthUtil.getUser();
		if(user.getUserCategory()==2){
			processConfig.put("factory_id",user.getFactoryId());
		}
		IPage<ProcessConfigEntity> pages = processConfigService.page(Condition.getPage(query), Condition.getQueryWrapper(processConfig, ProcessConfigEntity.class));
		return R.data(ProcessConfigWrapper.build().pageVO(pages));
	}

	/**
	 * 工序配置表 自定义分页
	 */
	@GetMapping("/page")
	@ApiOperationSupport(order = 3)
	@ApiOperation(value = "分页", notes = "传入processConfig")
	public R<IPage<ProcessConfigVO>> page(ProcessConfigVO processConfig, Query query) {
		IPage<ProcessConfigVO> pages = processConfigService.selectProcessConfigPage(Condition.getPage(query), processConfig);
		return R.data(pages);
	}

	/**
	 * 工序配置表 新增
	 */
	@PostMapping("/save")
	@ApiOperationSupport(order = 4)
	@ApiOperation(value = "新增", notes = "传入processConfig")
	public R save(@Valid @RequestBody ProcessConfigEntity processConfig) {
		return R.status(processConfigService.save(processConfig));
	}

	/**
	 * 工序配置表 修改
	 */
	@PostMapping("/update")
	@ApiOperationSupport(order = 5)
	@ApiOperation(value = "修改", notes = "传入processConfig")
	public R update(@Valid @RequestBody ProcessConfigEntity processConfig) {
		return R.status(processConfigService.updateById(processConfig));
	}

	/**
	 * 工序配置表 新增或修改
	 */
	@PostMapping("/submit")
	@ApiOperationSupport(order = 6)
	@ApiOperation(value = "新增或修改", notes = "传入processConfig")
	public R submit(@Valid @RequestBody ProcessConfigEntity processConfig) {
		List<Long> processIds = Func.toLongList(processConfig.getProcessIds());
		List<ProcessEntity> processList = processService.list(Wrappers.<ProcessEntity>lambdaQuery().in(ProcessEntity::getId,processIds));
		Map<Long,ProcessEntity> map = processList.stream().collect(Collectors.toMap(ProcessEntity::getId,ProcessEntity->ProcessEntity));
		List<String> processNames = new ArrayList<>();
		int count = 0;
		for(Long id : processIds){
			ProcessEntity processEntity = map.get(id);
			processNames.add(processEntity.getCode()+"-"+processEntity.getName());
			if(processEntity.getIsDownline()==1){
				count+=1;
			}
		}
		if(count!=1){
			return R.fail("当前选择了"+count+"个下线工序，仅必须只选择1个下线工序");
		}
		processConfig.setProcessNames(String.join(">",processNames));
		return R.status(processConfigService.saveOrUpdate(processConfig));
	}

	/**
	 * 工序配置表 删除
	 */
	@PostMapping("/remove")
	@ApiOperationSupport(order = 7)
	@ApiOperation(value = "逻辑删除", notes = "传入ids")
	public R remove(@ApiParam(value = "主键集合", required = true) @RequestParam String ids) {
		return R.status(processConfigService.deleteLogic(Func.toLongList(ids)));
	}


	/**
	 * 导出数据
	 */
	@GetMapping("/export-processConfig")
	@ApiOperationSupport(order = 9)
	@ApiOperation(value = "导出数据", notes = "传入processConfig")
	public void exportProcessConfig(@ApiIgnore @RequestParam Map<String, Object> processConfig, BladeUser bladeUser, HttpServletResponse response) {
		QueryWrapper<ProcessConfigEntity> queryWrapper = Condition.getQueryWrapper(processConfig, ProcessConfigEntity.class);
		//if (!AuthUtil.isAdministrator()) {
		//	queryWrapper.lambda().eq(ProcessConfig::getTenantId, bladeUser.getTenantId());
		//}
		queryWrapper.lambda().eq(ProcessConfigEntity::getIsDeleted, BladeConstant.DB_NOT_DELETED);
		List<ProcessConfigExcel> list = processConfigService.exportProcessConfig(queryWrapper);
		ExcelUtil.export(response, "工序配置表数据" + DateUtil.time(), "工序配置表数据表", list, ProcessConfigExcel.class);
	}


	/**
	 * 产品型号表 下拉框
	 */
	@GetMapping("/select")
	@ApiOperationSupport(order = 2)
	@ApiOperation(value = "下拉框", notes = "传入factory")
	public R<List<ProcessConfigEntity>> select(ProcessConfigEntity processConfig, Query query) {
		BladeUser user = AuthUtil.getUser();
		if(user.getUserCategory()==2){
			processConfig.setFactoryId(user.getFactoryId());
		}
		List<ProcessConfigEntity> list = processConfigService.list(Condition.getQueryWrapper(processConfig));
		return R.data(list);
	}

}
